## arb 6.0.3

=== Makefile ===
# =============================================================== #
#                                                                 #
#   File      : Makefile                                          #
#                                                                 #
#   Institute of Microbiology (Technical University Munich)       #
#   http://www.arb-home.de/                                       #
#                                                                 #
# =============================================================== #

# -----------------------------------------------------
# The ARB Makefile is aware of the following defines:
#
# CC                    C compiler (should be defined by OS)
# CXX                   C++ compiler (should be defined by OS)
#
# BUILDHOST_64=0/1      1=>compile on 64 bit platform (defaults to ARB_64)
# DEVELOPER=name        special compilation (values: ANY,RELEASE,your name)
# OPENGL=0/1            whether OPENGL is available
#
# -----------------------------------------------------
# ARB Makefile and ARB source code are aware of the following defines:
#
# $(MACH)               name of the machine (LINUX or DARWIN; see config.makefile)
# DEBUG                 compiles the DEBUG sections
# DEBUG_GRAPHICS        all X-graphics are flushed immediately (for debugging)
# ARB_64=0/1            1=>compile 64 bit version
# UNIT_TESTS=0/1        1=>compile in unit tests and call them after build
# COVERAGE=0/1/2        compile in gcov support (useful together with UNIT_TESTS=1)
#                       0=no, 1+2=compile in, 1=show
# STABS=0/1             force stabs format? (0 = "use default format")
#
# -----------------------------------------------------
# The ARB source code is aware of the following defines:
#
# NDEBUG                doesn't compile the DEBUG sections
# DEVEL_$(DEVELOPER)    developer-dependent flag (enables you to have private sections in code)
#                       DEVELOPER='ANY' (default setting) will be ignored
#                       configurable in config.makefile
#
# -----------------------------------------------------
# Read configuration 
include config.makefile

# set defaults for variables commented out in config.makefile:
ifndef DARWIN
	DARWIN:=0
endif
ifndef LINUX
	LINUX:=0
endif
ifndef DEBIAN
	DEBIAN:=0
endif
ifndef REDHAT
	REDHAT:=0
endif
ifndef ARB_64
	ARB_64=1#default to 64bit
endif

# compiler settings:
ifneq ($(CC),use__A_CC__instead_of__CC)

A_CC:=$(CC)# compile C
A_CXX:=$(CXX)# compile C++

# uncomment to ensure no submakefile uses CC and CXX directly
override CC:=use__A_CC__instead_of__CC
override CXX:=use__A_CXX__instead_of__CXX

endif

export CC CXX A_CC A_CXX

ifeq ($(LD_LIBRARY_PATH),'')
LD_LIBRARY_PATH:=${ARBHOME}/lib
endif

ifeq ($(DARWIN),1)
LD_LIBRARY_PATH:=${ARBHOME}/lib
endif

FORCEMASK = umask 002
NODIR=--no-print-directory

SED:=$(ARBHOME)/SH/arb_sed
READLINK:=$(ARBHOME)/SH/arb_readlink

# ---------------------- compiler version detection

# supported gcc versions:
ALLOWED_gcc_VERSIONS=\
        4.3.1 4.3.2 4.3.3 4.3.4 \
        4.4.1       4.4.3       4.4.5 4.4.6  4.4.7 \
              4.5.2 \
        4.6.1 4.6.2 4.6.3 \
        4.7.1 4.7.2 4.7.3 \
  4.8.0 4.8.1 4.8.2 4.8.3 4.8.4 4.8.5 \
  4.9.0 4.9.1 4.9.2 4.9.3 \
  5.1.0 5.2.0 \


# supported clang versions:
ALLOWED_clang_VERSIONS=\
	4.2.1 \

# ----------------------

COMPILER_INFO:=$(shell SOURCE_TOOLS/arb_compiler_version.pl $(A_CXX))
COMPILER_NAME:=$(word 1,$(COMPILER_INFO))
COMPILER_VERSION:=$(word 2,$(COMPILER_INFO))

USE_CLANG:=0
ifneq ($(COMPILER_NAME),gcc)
 ifeq ($(COMPILER_NAME),clang)
  USE_CLANG:=1
 else
  $(error failed to detect COMPILER_NAME (got '$(COMPILER_NAME)', expected 'clang' or 'gcc'))
 endif
endif

ifeq ($(USE_CLANG),1)
ALLOWED_COMPILER_VERSIONS=$(ALLOWED_clang_VERSIONS)
else
ALLOWED_COMPILER_VERSIONS=$(ALLOWED_gcc_VERSIONS)
endif

COMPILER_VERSION_ALLOWED=$(strip $(subst ___,,$(foreach version,$(ALLOWED_COMPILER_VERSIONS),$(findstring ___$(version)___,___$(COMPILER_VERSION)___))))

#---------------------- split gcc version 

SPLITTED_VERSION:=$(subst ., ,$(COMPILER_VERSION))

USE_GCC_MAJOR:=$(word 1,$(SPLITTED_VERSION))
USE_GCC_MINOR:=$(word 2,$(SPLITTED_VERSION))
USE_GCC_PATCHLEVEL:=$(word 3,$(SPLITTED_VERSION))

USE_GCC_452_OR_HIGHER:=
USE_GCC_47_OR_HIGHER:=
USE_GCC_48_OR_HIGHER:=

ifeq ($(USE_GCC_MAJOR),4)
 ifeq ($(USE_GCC_MINOR),5)
  ifneq ('$(findstring $(USE_GCC_PATCHLEVEL),23456789)','')
   USE_GCC_452_OR_HIGHER:=yes
  endif
 else
  ifneq ('$(findstring $(USE_GCC_MINOR),6789)','')
   USE_GCC_452_OR_HIGHER:=yes
   ifneq ($(USE_GCC_MINOR),6)
    USE_GCC_47_OR_HIGHER:=yes
    ifneq ($(USE_GCC_MINOR),7)
     USE_GCC_48_OR_HIGHER:=yes
    endif
   endif
  endif
 endif
else
 USE_GCC_452_OR_HIGHER:=yes
 USE_GCC_47_OR_HIGHER:=yes
 USE_GCC_48_OR_HIGHER:=yes
endif

#---------------------- define special directories for non standard builds

ifeq ($(DARWIN),1)
	OSX_FW:=/System/Library/Frameworks
	OSX_FW_OPENGL:=$(OSX_FW)/OpenGL.framework/Versions/A/Libraries
	OSX_FW_GLUT:=$(OSX_FW)/GLUT.framework/Versions/A/Libraries
	OSX_FW_IMAGEIO:=$(OSX_FW)/ApplicationServices.framework/Versions/A/Frameworks/ImageIO.framework/Versions/A/Resources
endif

#----------------------

ifeq ($(DARWIN),1)
	LINK_STATIC=1# link static
else
	LINK_STATIC=0# link dynamically
#	LINK_STATIC=1# link static (testing only)
endif

shared_cflags :=# flags for shared lib compilation
lflags :=# linker flags
clflags :=# linker flags (when passed through gcc)
extended_warnings :=# warning flags for C and C++-compiler
extended_cpp_warnings :=# warning flags for C++-compiler only


ifeq ($(DEBUG),0)
	dflags := -DNDEBUG# defines
	ifeq ($(USE_CLANG),1)
		cflags := -O3# compiler flags (C and C++)
	else
		cflags := -O4# compiler flags (C and C++)
		lflags += -O2# linker flags
		clflags += -Wl,-O2# passthrough linker flags
	endif
endif

ifeq ($(DEBIAN),1)
	lflags += -rpath=/usr/lib/arb/lib -z relro
	clflags += -Wl,-rpath=/usr/lib/arb/lib -Wl,-z,relro
endif

ifeq ($(DEBUG),1)
	dflags := -DDEBUG

	gdb_common := -g -g3 -ggdb -ggdb3

ifeq ($(STABS),1)
	cflags := -O0  $(gdb_common) -gstabs+  # using stabs+ (enable this for bigger debug session: debugs inlines, quick var inspect, BUT valgrind stops working :/)
else
	cflags := -O0 $(gdb_common) # (using dwarf - cant debug inlines here, incredible slow on showing variable content)
endif

#	cflags := -O0 $(gdb_common) -gdwarf-3 # (specify explicit dwarf format)
#	cflags := -O0  $(gdb_common) -gstabs  # using stabs (same here IIRC)
#	cflags := -O2 $(gdb_common) # use this for callgrind (force inlining)

ifeq ($(DARWIN),0)
	lflags += -g
	clflags += -Wl,-g
endif

# control how much you get spammed
# (please do not change default in SVN, use developer specific setting as below)
	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --original# dont modify compiler output
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --hide-Noncopyable-advices
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --show-useless-Weff++
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --no-warnings
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --only-first-error
#	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --no-warnings --only-first-error
ifeq ($(DEVELOPER),ELMAR)
	POST_COMPILE := 2>&1 | $(ARBHOME)/SOURCE_TOOLS/postcompile.pl --only-first-error
endif


# Enable extra warnings
	extended_warnings :=
	extended_cpp_warnings :=

#       C and C++ 
	extended_warnings     += -Wwrite-strings -Wunused -Wno-aggregate-return -Wshadow

#       C++ only 
	extended_cpp_warnings += -Wnon-virtual-dtor -Wreorder -Wpointer-arith -Wdisabled-optimization -Wmissing-format-attribute
	extended_cpp_warnings += -Wctor-dtor-privacy# < gcc 3
# 	extended_cpp_warnings += -Wfloat-equal# gcc 3.0

# ------- above only warnings available in 3.0

 ifneq ('$(COMPILER_VERSION)','4.7.3') # g++ crashes on GenomeImport.cxx when -Weffc++ is active (bug reported)
	extended_cpp_warnings += -Weffc++# gcc 3.0.1
 endif
	extended_cpp_warnings += -Wmissing-noreturn# gcc 3.0.2
#	extended_cpp_warnings += -Wold-style-cast# gcc 3.0.4 (warn about 28405 old-style casts)
	extended_cpp_warnings += -Winit-self# gcc 3.4.0
	extended_cpp_warnings += -Wstrict-aliasing# gcc 3.4
	extended_cpp_warnings += -Wextra# gcc 3.4.0
 ifeq ('$(USE_GCC_452_OR_HIGHER)','yes')
	extended_cpp_warnings += -Wlogical-op# gcc 4.5.2
 endif

 ifeq ($(DEBUG_GRAPHICS),1)
	dflags += -DDEBUG_GRAPHICS
 endif
endif

#---------------------- turn off clang bogus warnings

ifeq ($(USE_CLANG),1)
# -Wmismatched-tags warns about struct/class mismatch in forward declarations (which is explicitely allowed)
# -Wchar-subscripts reports too many bogus warnings for "array['x']" (when 'x' is known to be in range [0..128])
# -Wunused-private-field report too many false positives (currently ~ 2 of 3)
# -Wstring-plus-int warns about common ARB coding practice
# -Wgnu-static-float-init warns about accepted GNU extension
	extended_cpp_warnings += -Wno-mismatched-tags -Wno-char-subscripts -Wno-unused-private-field -Wno-string-plus-int -Wno-gnu-static-float-init
endif

#---------------------- developer

ifneq ($(DEVELOPER),ANY) # ANY=default setting (skip all developer specific code)
	dflags += -DDEVEL_$(DEVELOPER)# activate developer/release specific code
endif

ifndef SHOWTODO
 ifeq ($(DEVELOPER),RALF)
	SHOWTODO:=1
 else
	SHOWTODO:=0
 endif
endif
ifeq ($(SHOWTODO),1)
	dflags += -DWARN_TODO# activate "TODO" warnings
endif

#---------------------- 32 or 64 bit

ifndef BUILDHOST_64
	BUILDHOST_64:=$(ARB_64)# assume build host is same as version (see config.makefile)
endif

cross_cflags:=
cross_lflags:=
cross_clflags:=

ifeq ($(ARB_64),1)
	dflags += -DARB_64 #-fPIC 
	shared_cflags += -fPIC

	ifeq ($(BUILDHOST_64),1)
#		build 64-bit ARB version on 64-bit host
		CROSS_LIB:=# empty = autodetect below
		ifeq ($(DARWIN),1)
			cross_cflags  += -arch x86_64
			cross_lflags  += -arch x86_64
			cross_clflags += -arch x86_64
		endif
	else
#		build 64-bit ARB version on 32-bit host
		CROSS_LIB:=/lib64
		cross_cflags += -m64
		cross_lflags += -m64 -m elf_x86_64
		cross_clflags += -m64 -Wl,-m64,-m,elf_x86_64
	endif
else
	ifeq ($(BUILDHOST_64),1)
#		build 32-bit ARB version on 64-bit host
		CROSS_LIB:=# empty = autodetect below
		cross_cflags += -m32
		cross_lflags += -m32 -m elf_i386 
		cross_clflags += -m32 -Wl,-m32,-m,elf_i386 
	else
#		build 32-bit ARB version on 32-bit host
		CROSS_LIB:=/lib
	endif
endif

cflags  += $(cross_cflags)
lflags  += $(cross_lflags)
clflags += $(cross_clflags)

ifeq ('$(CROSS_LIB)','')
# autodetect libdir
	ifeq ($(ARB_64),1)
		CROSS_LIB:=$(shell (test -d /lib64 && echo lib64) || echo lib)
	else
		CROSS_LIB:=$(shell (test -d /lib32 && echo lib32) || echo lib)
	endif
endif

#---------------------- unit tests

ifndef UNIT_TESTS
	UNIT_TESTS=0#default is "no tests"
endif
ifeq ($(UNIT_TESTS),1)
	dflags += -DUNIT_TESTS
	UNIT_TESTER_LIB=UNIT_TESTER/UNIT_TESTER.a
else
	UNIT_TESTER_LIB=
endif

#---------------------- use gcov

ifndef COVERAGE
	COVERAGE=0#default is "no"
endif
ifneq ($(COVERAGE),0)
	GCOVFLAGS=-ftest-coverage -fprofile-arcs
	cflags += $(GCOVFLAGS)
	EXECLIBS=-lgcov
else
	GCOVFLAGS=
	EXECLIBS=
endif

#---------------------- other flags

dflags += -D$(MACH) # define machine

ifeq ($(DARWIN),1)
	shared_cflags += -fno-common
else
	dflags +=  $(shell getconf LFS_CFLAGS)
endif

cflags += -pipe
cflags += -fmessage-length=0# don't wrap compiler output
cflags += -fshow-column# show columns
cflags += -funit-at-a-time
cflags += -fPIC
cflags += -fno-common# link all global data into one namespace
cflags += -fstrict-aliasing# gcc 3.4
ifeq ('$(USE_GCC_48_OR_HIGHER)','yes')
 cflags += -fno-diagnostics-show-caret#gcc 4.8 (4.7.?)
endif
#cflags += -save-temps# uncomment to see preprocessor output

#---------------------- X11 location

ifeq ($(DARWIN),1)
	XHOME:=$(PREFIX)
else

=== AISC/Makefile ===
# for variables passed from parent makefile see ../SOURCE_TOOLS/parent_make.txt

.SUFFIXES: .o .c .depend
SOURCES = $(wildcard *.c)
OBJECTS = $(subst .c,.o,$(SOURCES))

BINARY=aisc

LOCAL_DEFINES=-DSIMPLE_ARB_ASSERT
LOCAL_MAKEDEPENDFLAGS=$(MAKEDEPENDFLAGS) $(LOCAL_DEFINES)

$(MAIN): proto
	$(MAKE) $(BINARY)

$(BINARY): $(OBJECTS)
	$(LINK_EXECUTABLE) $@ $(OBJECTS) $(EXECLIBS)

.c.o:
	$(A_CXX) -x c++ $(cflags) $(cxxflags) $(LOCAL_DEFINES) -c $< $(CXX_INCLUDES) $(POST_COMPILE)

DEPENDS = $(OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(LOCAL_MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(LOCAL_MAKEDEPENDFLAGS) $< 2>/dev/null >$@

clean:
	rm -f $(OBJECTS) $(BINARY)

proto:
	../AISC_MKPTPS/aisc_mkpt -P -G -w aisc_proto.h *.c >aisc_proto.h.tmp
	../SOURCE_TOOLS/mv_if_diff aisc_proto.h.tmp aisc_proto.h

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

aisc.o: aisc_def.h
aisc.o: aisc_inline.h
aisc.o: aisc_interpreter.h
aisc.o: aisc_location.h
aisc.o: aisc_parser.h
aisc.o: aisc_proto.h
aisc.o: aisc_token.h
aisc.o: $(ARBHOME)/INCLUDE/arb_assert.h
aisc.o: $(ARBHOME)/INCLUDE/arb_simple_assert.h
aisc.o: $(ARBHOME)/INCLUDE/arbtools.h
aisc.o: $(ARBHOME)/INCLUDE/attributes.h
aisc.o: $(ARBHOME)/INCLUDE/cxxforward.h
aisc.o: $(ARBHOME)/INCLUDE/dupstr.h
aisc.o: $(ARBHOME)/INCLUDE/gccver.h
aisc.o: $(ARBHOME)/INCLUDE/test_global.h

aisc_commands.o: aisc_def.h
aisc_commands.o: aisc_eval.h
aisc_commands.o: aisc_inline.h
aisc_commands.o: aisc_interpreter.h
aisc_commands.o: aisc_location.h
aisc_commands.o: aisc_parser.h
aisc_commands.o: aisc_proto.h
aisc_commands.o: aisc_token.h
aisc_commands.o: $(ARBHOME)/INCLUDE/arb_assert.h
aisc_commands.o: $(ARBHOME)/INCLUDE/arb_simple_assert.h
aisc_commands.o: $(ARBHOME)/INCLUDE/arbtools.h
aisc_commands.o: $(ARBHOME)/INCLUDE/attributes.h
aisc_commands.o: $(ARBHOME)/INCLUDE/cxxforward.h
aisc_commands.o: $(ARBHOME)/INCLUDE/dupstr.h
aisc_commands.o: $(ARBHOME)/INCLUDE/gccver.h
aisc_commands.o: $(ARBHOME)/INCLUDE/test_global.h

aisc_eval.o: aisc_def.h
aisc_eval.o: aisc_eval.h
aisc_eval.o: aisc_inline.h
aisc_eval.o: aisc_location.h
aisc_eval.o: aisc_proto.h
aisc_eval.o: $(ARBHOME)/INCLUDE/arb_assert.h
aisc_eval.o: $(ARBHOME)/INCLUDE/arb_simple_assert.h
aisc_eval.o: $(ARBHOME)/INCLUDE/arbtools.h
aisc_eval.o: $(ARBHOME)/INCLUDE/attributes.h
aisc_eval.o: $(ARBHOME)/INCLUDE/cxxforward.h
aisc_eval.o: $(ARBHOME)/INCLUDE/dupstr.h
aisc_eval.o: $(ARBHOME)/INCLUDE/gccver.h
aisc_eval.o: $(ARBHOME)/INCLUDE/test_global.h

aisc_mix.o: aisc_def.h
aisc_mix.o: aisc_inline.h
aisc_mix.o: aisc_interpreter.h
aisc_mix.o: aisc_location.h
aisc_mix.o: aisc_parser.h
aisc_mix.o: aisc_proto.h
aisc_mix.o: aisc_token.h
aisc_mix.o: $(ARBHOME)/INCLUDE/arb_assert.h
aisc_mix.o: $(ARBHOME)/INCLUDE/arb_simple_assert.h
aisc_mix.o: $(ARBHOME)/INCLUDE/arbtools.h
aisc_mix.o: $(ARBHOME)/INCLUDE/attributes.h
aisc_mix.o: $(ARBHOME)/INCLUDE/cxxforward.h
aisc_mix.o: $(ARBHOME)/INCLUDE/dupstr.h
aisc_mix.o: $(ARBHOME)/INCLUDE/gccver.h
aisc_mix.o: $(ARBHOME)/INCLUDE/test_global.h

aisc_parser.o: aisc_def.h
aisc_parser.o: aisc_inline.h
aisc_parser.o: aisc_location.h
aisc_parser.o: aisc_parser.h
aisc_parser.o: aisc_token.h
aisc_parser.o: $(ARBHOME)/INCLUDE/arb_assert.h
aisc_parser.o: $(ARBHOME)/INCLUDE/arb_simple_assert.h
aisc_parser.o: $(ARBHOME)/INCLUDE/arbtools.h
aisc_parser.o: $(ARBHOME)/INCLUDE/attributes.h
aisc_parser.o: $(ARBHOME)/INCLUDE/cxxforward.h
aisc_parser.o: $(ARBHOME)/INCLUDE/dupstr.h
aisc_parser.o: $(ARBHOME)/INCLUDE/gccver.h
aisc_parser.o: $(ARBHOME)/INCLUDE/test_global.h

aisc_var_ref.o: aisc_def.h
aisc_var_ref.o: aisc_inline.h
aisc_var_ref.o: aisc_interpreter.h
aisc_var_ref.o: aisc_location.h
aisc_var_ref.o: aisc_parser.h
aisc_var_ref.o: aisc_proto.h
aisc_var_ref.o: aisc_token.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/arb_assert.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/arb_simple_assert.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/arbtools.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/attributes.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/cxxforward.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/dupstr.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/gccver.h
aisc_var_ref.o: $(ARBHOME)/INCLUDE/test_global.h

=== ARBDB/Makefile ===
# for variables passed from parent makefile see ../SOURCE_TOOLS/parent_make.txt
.SUFFIXES: .o .cxx .depend

# objects with autogenerated prototypes (gb_prot.h + ad_prot.h + ad_k_prot.h)
GB_O = \
	adTest.o \
	ad_load.o \
	ad_save_load.o \
	adcomm.o \
	adhash.o  \
	adcache.o  \
	adhashtools.o \
	adlang1.o \
	adlink.o \
	admalloc.o \
	admatch.o \
	admath.o \
	adoptimize.o \
	adperl.o \
	adstring.o \
	adfile.o \
	adsystem.o \
	adtcp.o \
	adtune.o \
	arbdb.o \
        adExperiment.o \
        adGene.o \
        ad_core.o \
        adcompr.o \
        adindex.o \
        admap.o \
        adquery.o \
        adsocket.o \


# objects with autogenerated prototypes (gb_t_prot.h + ad_t_prot.h)
GB_T =  \
	adChangeKey.o \
	adRevCompl.o \
	aditem.o \
	adname.o \
	adseqcompr.o \
	adtables.o \
	adtools.o \
	adtree.o \
        adali.o \


# c++-only objects
GB_PP = \
	arbdbpp.o \

# objects w/o autogenerated prototypes
GB_X =  \
	ad_config.o \

OBJECTS = $(GB_O) $(GB_T) $(GB_PP) $(GB_X)

LIB_SHARED=../lib/$(MAIN:.a=).$(SHARED_LIB_SUFFIX)

# MAIN contains .a (instead of wanted .so). Translate via do_...-target
it: do_$(MAIN)

do_ARBDB.a:
	@echo "Error: MAIN='$(MAIN)' is set wrong"
	false

do_libARBDB.a: $(LIB_SHARED)

$(LIB_SHARED): $(OBJECTS)
	$(LINK_SHARED_LIB) $(LIB_SHARED) $(OBJECTS)

.cxx.o:
	$(A_CXX) $(shared_cflags) $(cflags) $(cxxflags) -c $< $(CXX_INCLUDES) $(POST_COMPILE)

proto:	global_proto local_proto

local_proto: lpro tlpro

lpro: $(GB_O:.o=.cxx)
	../AISC_MKPTPS/aisc_mkpt -c "Internal database interface" -G -w gb_prot.h -F ^gb_,^gbs_,^gbcm,^gbm_,^gbl_ $^ >gb_prot.h.tmp
	../SOURCE_TOOLS/mv_if_diff gb_prot.h.tmp gb_prot.h

tlpro: $(GB_T:.o=.cxx)
	../AISC_MKPTPS/aisc_mkpt -c "Internal toolkit" -G -w gb_t_prot.h -F ^gb_,^gbt_,^gbs_ $^ >gb_t_prot.h.tmp
	../SOURCE_TOOLS/mv_if_diff gb_t_prot.h.tmp gb_t_prot.h

global_proto: pro ppro tpro cbpro

pro: $(GB_O:.o=.cxx) 
	../AISC_MKPTPS/aisc_mkpt -c "ARB database interface" -G -P -w ad_prot.h -F ^GB_,^GEN_,^EXP_,^GBS_,^GBT_,^GBCM,^GBC_ -S callback $^ >ad_prot.h.tmp
	../SOURCE_TOOLS/mv_if_diff ad_prot.h.tmp ad_prot.h

cbpro: $(GB_O:.o=.cxx)
	../AISC_MKPTPS/aisc_mkpt -c "ARB database callback interface" -G -w ad_cb_prot.h -F '^GB_+callback' $^ >ad_cb_prot.h.tmp
	../SOURCE_TOOLS/mv_if_diff ad_cb_prot.h.tmp ad_cb_prot.h

ppro: $(GB_O:.o=.cxx)
	../AISC_MKPTPS/aisc_mkpt -c "ARB perl interface" -G -w ad_p_prot.h -F ^GBP_ $^ >ad_p_prot.h.tmp
	../SOURCE_TOOLS/mv_if_diff ad_p_prot.h.tmp ad_p_prot.h

tpro: $(GB_T:.o=.cxx)
	../AISC_MKPTPS/aisc_mkpt -c "ARB toolkit" -G -w ad_t_prot.h -F ^GB_,^GEN_,^EXP_,^GBT_ $^ >ad_t_prot.h.tmp
	../SOURCE_TOOLS/mv_if_diff ad_t_prot.h.tmp ad_t_prot.h

wc:
	wc *.[ch]

clean:
	rm -f $(OBJECTS) *.a *.so

DEPENDS = $(OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

ad_config.o: ad_config.h
ad_config.o: ad_prot.h
ad_config.o: ad_t_prot.h
ad_config.o: arbdb.h
ad_config.o: arbdb_base.h
ad_config.o: arbdbt.h
ad_config.o: gb_local.h
ad_config.o: gb_prot.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_assert.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_core.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_defs.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_error.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_msg.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_strarray.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_strbuf.h
ad_config.o: $(ARBHOME)/INCLUDE/arb_string.h
ad_config.o: $(ARBHOME)/INCLUDE/arbtools.h
ad_config.o: $(ARBHOME)/INCLUDE/attributes.h
ad_config.o: $(ARBHOME)/INCLUDE/cxxforward.h
ad_config.o: $(ARBHOME)/INCLUDE/downcast.h
ad_config.o: $(ARBHOME)/INCLUDE/dupstr.h
ad_config.o: $(ARBHOME)/INCLUDE/gccver.h
ad_config.o: $(ARBHOME)/INCLUDE/smartptr.h
ad_config.o: $(ARBHOME)/INCLUDE/static_assert.h
ad_config.o: $(ARBHOME)/INCLUDE/test_global.h
ad_config.o: $(ARBHOME)/INCLUDE/test_unit.h

ad_core.o: ad_hcb.h
ad_core.o: ad_prot.h
ad_core.o: arbdb.h
ad_core.o: arbdb_base.h
ad_core.o: gb_cb.h
ad_core.o: gb_data.h
ad_core.o: gb_header.h
ad_core.o: gb_index.h
ad_core.o: gb_key.h
ad_core.o: gb_local.h
ad_core.o: gb_localdata.h
ad_core.o: gb_main.h
ad_core.o: gb_memory.h
ad_core.o: gb_prot.h
ad_core.o: gb_storage.h
ad_core.o: gb_ts.h
ad_core.o: gb_tune.h
ad_core.o: $(ARBHOME)/INCLUDE/arb_assert.h
ad_core.o: $(ARBHOME)/INCLUDE/arb_core.h
ad_core.o: $(ARBHOME)/INCLUDE/arb_error.h
ad_core.o: $(ARBHOME)/INCLUDE/arb_msg.h
ad_core.o: $(ARBHOME)/INCLUDE/arb_string.h
ad_core.o: $(ARBHOME)/INCLUDE/arbtools.h
ad_core.o: $(ARBHOME)/INCLUDE/attributes.h
ad_core.o: $(ARBHOME)/INCLUDE/cb.h
ad_core.o: $(ARBHOME)/INCLUDE/cb_base.h
ad_core.o: $(ARBHOME)/INCLUDE/cbtypes.h
ad_core.o: $(ARBHOME)/INCLUDE/cxxforward.h
ad_core.o: $(ARBHOME)/INCLUDE/dupstr.h
ad_core.o: $(ARBHOME)/INCLUDE/gccver.h
ad_core.o: $(ARBHOME)/INCLUDE/smartptr.h
ad_core.o: $(ARBHOME)/INCLUDE/static_assert.h
ad_core.o: $(ARBHOME)/INCLUDE/test_global.h
ad_core.o: $(ARBHOME)/INCLUDE/ttypes.h

ad_load.o: ad_io_inline.h
ad_load.o: ad_prot.h
ad_load.o: ad_t_prot.h
ad_load.o: arbdb.h
ad_load.o: arbdb_base.h
ad_load.o: arbdbt.h
ad_load.o: gb_cb.h
ad_load.o: gb_data.h
ad_load.o: gb_header.h
ad_load.o: gb_key.h
ad_load.o: gb_load.h
ad_load.o: gb_local.h
ad_load.o: gb_localdata.h
ad_load.o: gb_main.h
ad_load.o: gb_map.h
ad_load.o: gb_memory.h
ad_load.o: gb_prot.h
ad_load.o: gb_storage.h
ad_load.o: gb_tune.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_assert.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_core.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_defs.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_error.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_file.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_msg.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_str.h
ad_load.o: $(ARBHOME)/INCLUDE/arb_string.h
ad_load.o: $(ARBHOME)/INCLUDE/arbtools.h
ad_load.o: $(ARBHOME)/INCLUDE/attributes.h
ad_load.o: $(ARBHOME)/INCLUDE/cb.h
ad_load.o: $(ARBHOME)/INCLUDE/cb_base.h
ad_load.o: $(ARBHOME)/INCLUDE/cbtypes.h
ad_load.o: $(ARBHOME)/INCLUDE/cxxforward.h
ad_load.o: $(ARBHOME)/INCLUDE/downcast.h
ad_load.o: $(ARBHOME)/INCLUDE/dupstr.h
ad_load.o: $(ARBHOME)/INCLUDE/gccver.h
ad_load.o: $(ARBHOME)/INCLUDE/smartptr.h
ad_load.o: $(ARBHOME)/INCLUDE/static_assert.h
ad_load.o: $(ARBHOME)/INCLUDE/test_global.h
ad_load.o: $(ARBHOME)/INCLUDE/ttypes.h

ad_save_load.o: ad_io_inline.h
ad_save_load.o: ad_prot.h
ad_save_load.o: arbdb.h
ad_save_load.o: arbdb_base.h
ad_save_load.o: gb_cb.h
ad_save_load.o: gb_data.h
ad_save_load.o: gb_header.h
ad_save_load.o: gb_key.h
ad_save_load.o: gb_load.h
ad_save_load.o: gb_local.h
ad_save_load.o: gb_main.h
ad_save_load.o: gb_map.h
ad_save_load.o: gb_memory.h
ad_save_load.o: gb_prot.h
ad_save_load.o: gb_storage.h
ad_save_load.o: gb_tune.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_assert.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_core.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_diff.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_error.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_file.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_msg.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arb_string.h
ad_save_load.o: $(ARBHOME)/INCLUDE/arbtools.h
ad_save_load.o: $(ARBHOME)/INCLUDE/attributes.h
ad_save_load.o: $(ARBHOME)/INCLUDE/cb.h
ad_save_load.o: $(ARBHOME)/INCLUDE/cb_base.h
ad_save_load.o: $(ARBHOME)/INCLUDE/cbtypes.h
ad_save_load.o: $(ARBHOME)/INCLUDE/cxxforward.h
ad_save_load.o: $(ARBHOME)/INCLUDE/dupstr.h
ad_save_load.o: $(ARBHOME)/INCLUDE/gccver.h
ad_save_load.o: $(ARBHOME)/INCLUDE/smartptr.h
ad_save_load.o: $(ARBHOME)/INCLUDE/static_assert.h
ad_save_load.o: $(ARBHOME)/INCLUDE/test_global.h
ad_save_load.o: $(ARBHOME)/INCLUDE/test_unit.h
ad_save_load.o: $(ARBHOME)/INCLUDE/ttypes.h

adali.o: ad_prot.h
adali.o: ad_t_prot.h
adali.o: adGene.h
adali.o: arbdb.h
adali.o: arbdb_base.h
adali.o: arbdbt.h
adali.o: gb_local.h
adali.o: gb_prot.h
adali.o: $(ARBHOME)/INCLUDE/arb_assert.h
adali.o: $(ARBHOME)/INCLUDE/arb_core.h
adali.o: $(ARBHOME)/INCLUDE/arb_error.h
adali.o: $(ARBHOME)/INCLUDE/arb_msg.h
adali.o: $(ARBHOME)/INCLUDE/arb_strarray.h
adali.o: $(ARBHOME)/INCLUDE/arb_string.h
adali.o: $(ARBHOME)/INCLUDE/arbtools.h
adali.o: $(ARBHOME)/INCLUDE/attributes.h
adali.o: $(ARBHOME)/INCLUDE/cxxforward.h
adali.o: $(ARBHOME)/INCLUDE/downcast.h
adali.o: $(ARBHOME)/INCLUDE/dupstr.h
adali.o: $(ARBHOME)/INCLUDE/gccver.h
adali.o: $(ARBHOME)/INCLUDE/smartptr.h
adali.o: $(ARBHOME)/INCLUDE/static_assert.h
adali.o: $(ARBHOME)/INCLUDE/test_global.h
adali.o: $(ARBHOME)/INCLUDE/test_unit.h

adcache.o: ad_prot.h
adcache.o: arbdb.h
adcache.o: arbdb_base.h
adcache.o: gb_cb.h
adcache.o: gb_data.h
adcache.o: gb_local.h
adcache.o: gb_main.h
adcache.o: gb_memory.h
adcache.o: gb_prot.h
adcache.o: gb_storage.h
adcache.o: gb_tune.h
adcache.o: $(ARBHOME)/INCLUDE/arb_assert.h
adcache.o: $(ARBHOME)/INCLUDE/arb_core.h
adcache.o: $(ARBHOME)/INCLUDE/arb_error.h
adcache.o: $(ARBHOME)/INCLUDE/arb_msg.h
adcache.o: $(ARBHOME)/INCLUDE/arb_string.h
adcache.o: $(ARBHOME)/INCLUDE/arbtools.h
adcache.o: $(ARBHOME)/INCLUDE/attributes.h
adcache.o: $(ARBHOME)/INCLUDE/cb.h
adcache.o: $(ARBHOME)/INCLUDE/cb_base.h
adcache.o: $(ARBHOME)/INCLUDE/cbtypes.h
adcache.o: $(ARBHOME)/INCLUDE/cxxforward.h
adcache.o: $(ARBHOME)/INCLUDE/dupstr.h
adcache.o: $(ARBHOME)/INCLUDE/gccver.h
adcache.o: $(ARBHOME)/INCLUDE/smartptr.h
adcache.o: $(ARBHOME)/INCLUDE/static_assert.h
adcache.o: $(ARBHOME)/INCLUDE/test_global.h
adcache.o: $(ARBHOME)/INCLUDE/ttypes.h

adChangeKey.o: ad_prot.h
adChangeKey.o: ad_t_prot.h
adChangeKey.o: arbdb.h
adChangeKey.o: arbdb_base.h
adChangeKey.o: arbdbt.h
adChangeKey.o: gb_local.h
adChangeKey.o: gb_prot.h
adChangeKey.o: $(ARBHOME)/INCLUDE/arb_assert.h
adChangeKey.o: $(ARBHOME)/INCLUDE/arb_core.h
adChangeKey.o: $(ARBHOME)/INCLUDE/arb_error.h
adChangeKey.o: $(ARBHOME)/INCLUDE/arb_msg.h
adChangeKey.o: $(ARBHOME)/INCLUDE/arb_string.h
adChangeKey.o: $(ARBHOME)/INCLUDE/arbtools.h
adChangeKey.o: $(ARBHOME)/INCLUDE/attributes.h
adChangeKey.o: $(ARBHOME)/INCLUDE/cxxforward.h
adChangeKey.o: $(ARBHOME)/INCLUDE/downcast.h
adChangeKey.o: $(ARBHOME)/INCLUDE/dupstr.h
adChangeKey.o: $(ARBHOME)/INCLUDE/gccver.h
adChangeKey.o: $(ARBHOME)/INCLUDE/smartptr.h
adChangeKey.o: $(ARBHOME)/INCLUDE/static_assert.h
adChangeKey.o: $(ARBHOME)/INCLUDE/test_global.h

adcomm.o: ad_prot.h
adcomm.o: arbdb.h
adcomm.o: arbdb_base.h
adcomm.o: gb_cb.h
adcomm.o: gb_comm.h
adcomm.o: gb_data.h
adcomm.o: gb_header.h
adcomm.o: gb_key.h
adcomm.o: gb_local.h
adcomm.o: gb_localdata.h
adcomm.o: gb_main.h
adcomm.o: gb_memory.h
adcomm.o: gb_prot.h
adcomm.o: gb_storage.h
adcomm.o: gb_tune.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_assert.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_core.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_error.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_file.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_msg.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_signal.h
adcomm.o: $(ARBHOME)/INCLUDE/arb_string.h
adcomm.o: $(ARBHOME)/INCLUDE/arbtools.h
adcomm.o: $(ARBHOME)/INCLUDE/attributes.h
adcomm.o: $(ARBHOME)/INCLUDE/cb.h
adcomm.o: $(ARBHOME)/INCLUDE/cb_base.h
adcomm.o: $(ARBHOME)/INCLUDE/cbtypes.h
adcomm.o: $(ARBHOME)/INCLUDE/cxxforward.h
adcomm.o: $(ARBHOME)/INCLUDE/dupstr.h
adcomm.o: $(ARBHOME)/INCLUDE/gccver.h
adcomm.o: $(ARBHOME)/INCLUDE/SigHandler.h
adcomm.o: $(ARBHOME)/INCLUDE/smartptr.h
adcomm.o: $(ARBHOME)/INCLUDE/static_assert.h
adcomm.o: $(ARBHOME)/INCLUDE/test_global.h
adcomm.o: $(ARBHOME)/INCLUDE/ttypes.h

adcompr.o: ad_prot.h
adcompr.o: ad_t_prot.h
adcompr.o: arbdb.h
adcompr.o: arbdb_base.h
adcompr.o: arbdbt.h
adcompr.o: gb_cb.h
adcompr.o: gb_compress.h
adcompr.o: gb_data.h
adcompr.o: gb_header.h
adcompr.o: gb_key.h
adcompr.o: gb_local.h
adcompr.o: gb_localdata.h
adcompr.o: gb_main.h
adcompr.o: gb_memory.h
adcompr.o: gb_prot.h
adcompr.o: gb_storage.h
adcompr.o: gb_t_prot.h
adcompr.o: gb_tune.h

=== AWTC/Makefile ===
# for variables passed from parent makefile see ../SOURCE_TOOLS/parent_make.txt
.SUFFIXES: .o .cxx .depend

CPP_OBJECTS = $(subst .cxx,.o,$(wildcard *.cxx))

$(MAIN): $(CPP_OBJECTS)
	$(LINK_STATIC_LIB) $(MAIN) $(CPP_OBJECTS)
.cxx.o:
	$(A_CXX) $(cflags) $(cxxflags) -c $<  $(CXX_INCLUDES) $(POST_COMPILE)

clean:
	rm -f $(CPP_OBJECTS) *.a

DEPENDS = $(CPP_OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

AWTC_next_neighbours.o: awtc_next_neighbours.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/ad_prot.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aisc_global.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_assert.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_core.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_error.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_msg.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_strbuf.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arb_string.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbdb.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbdb_base.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbdbt.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/arbtools.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/attributes.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_base.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_keysym.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_root.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/aw_window.hxx
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/bytestring.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/cb.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/cb_base.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/cbtypes.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/client.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/client_types.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/cxxforward.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/downcast.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/dupstr.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/gccver.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/pos_range.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/PT_com.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/PT_global_defs.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/servercntrl.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/smartptr.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/static_assert.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/test_global.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/test_unit.h
AWTC_next_neighbours.o: $(ARBHOME)/INCLUDE/ttypes.h

AWTC_submission.o: $(ARBHOME)/INCLUDE/ad_prot.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_assert.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_core.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_error.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_msg.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_strarray.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_strbuf.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arb_string.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbdb.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbdb_base.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbdbt.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/arbtools.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/attributes.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_awar.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_awar_defs.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_awars.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_base.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_edit.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_keysym.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_msg.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_root.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/aw_window.hxx
AWTC_submission.o: $(ARBHOME)/INCLUDE/cb.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/cb_base.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/cbtypes.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/cxxforward.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/downcast.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/dupstr.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/gccver.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/smartptr.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/static_assert.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/test_global.h
AWTC_submission.o: $(ARBHOME)/INCLUDE/ttypes.h

=== CONVERTALN/Makefile ===
.SUFFIXES: .o .a .cxx .depend

OBJECTS= $(subst .cxx,.o,$(wildcard *.cxx))

$(MAIN): $(OBJECTS) check_error_codes
	$(LINK_STATIC_LIB) $(MAIN) $(OBJECTS)

check_error_codes:
	@./show_error_list.pl -check

.cxx.o:
	$(A_CXX) $(cflags) $(cxxflags) -c $< $(CXX_INCLUDES) $(POST_COMPILE)

proto:
	../AISC_MKPTPS/aisc_mkpt -P -G -w prototypes.h $(OBJECTS:.o=.cxx) >prototypes.h.tmp
	../SOURCE_TOOLS/mv_if_diff prototypes.h.tmp prototypes.h

clean:
	rm -f *.o $(BINARY)

DEPENDS = $(OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

convert.o: defs.h
convert.o: embl.h
convert.o: fun.h
convert.o: genbank.h
convert.o: global.h
convert.o: input_format.h
convert.o: macke.h
convert.o: parser.h
convert.o: prototypes.h
convert.o: rdp_info.h
convert.o: reader.h
convert.o: refs.h
convert.o: seq.h
convert.o: $(ARBHOME)/INCLUDE/arb_assert.h
convert.o: $(ARBHOME)/INCLUDE/arb_core.h
convert.o: $(ARBHOME)/INCLUDE/arb_defs.h
convert.o: $(ARBHOME)/INCLUDE/arbtools.h
convert.o: $(ARBHOME)/INCLUDE/attributes.h
convert.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
convert.o: $(ARBHOME)/INCLUDE/cxxforward.h
convert.o: $(ARBHOME)/INCLUDE/dupstr.h
convert.o: $(ARBHOME)/INCLUDE/gccver.h
convert.o: $(ARBHOME)/INCLUDE/smartptr.h
convert.o: $(ARBHOME)/INCLUDE/test_global.h

date.o: fun.h
date.o: global.h
date.o: prototypes.h
date.o: $(ARBHOME)/INCLUDE/arb_assert.h
date.o: $(ARBHOME)/INCLUDE/arb_core.h
date.o: $(ARBHOME)/INCLUDE/arb_defs.h
date.o: $(ARBHOME)/INCLUDE/arbtools.h
date.o: $(ARBHOME)/INCLUDE/attributes.h
date.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
date.o: $(ARBHOME)/INCLUDE/cxxforward.h
date.o: $(ARBHOME)/INCLUDE/dupstr.h
date.o: $(ARBHOME)/INCLUDE/gccver.h
date.o: $(ARBHOME)/INCLUDE/smartptr.h
date.o: $(ARBHOME)/INCLUDE/test_global.h
date.o: $(ARBHOME)/INCLUDE/test_unit.h

embl.o: defs.h
embl.o: embl.h
embl.o: fun.h
embl.o: genbank.h
embl.o: global.h
embl.o: input_format.h
embl.o: macke.h
embl.o: parser.h
embl.o: prototypes.h
embl.o: rdp_info.h
embl.o: reader.h
embl.o: refs.h
embl.o: seq.h
embl.o: wrap.h
embl.o: $(ARBHOME)/INCLUDE/arb_assert.h
embl.o: $(ARBHOME)/INCLUDE/arb_core.h
embl.o: $(ARBHOME)/INCLUDE/arb_defs.h
embl.o: $(ARBHOME)/INCLUDE/arbtools.h
embl.o: $(ARBHOME)/INCLUDE/attributes.h
embl.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
embl.o: $(ARBHOME)/INCLUDE/cxxforward.h
embl.o: $(ARBHOME)/INCLUDE/dupstr.h
embl.o: $(ARBHOME)/INCLUDE/gccver.h
embl.o: $(ARBHOME)/INCLUDE/smartptr.h
embl.o: $(ARBHOME)/INCLUDE/test_global.h
embl.o: $(ARBHOME)/INCLUDE/test_unit.h

fconv.o: defs.h
fconv.o: fun.h
fconv.o: global.h
fconv.o: prototypes.h
fconv.o: $(ARBHOME)/INCLUDE/ad_prot.h
fconv.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
fconv.o: $(ARBHOME)/INCLUDE/arb_assert.h
fconv.o: $(ARBHOME)/INCLUDE/arb_core.h
fconv.o: $(ARBHOME)/INCLUDE/arb_defs.h
fconv.o: $(ARBHOME)/INCLUDE/arb_diff.h
fconv.o: $(ARBHOME)/INCLUDE/arb_error.h
fconv.o: $(ARBHOME)/INCLUDE/arb_file.h
fconv.o: $(ARBHOME)/INCLUDE/arb_msg.h
fconv.o: $(ARBHOME)/INCLUDE/arb_string.h
fconv.o: $(ARBHOME)/INCLUDE/arbdb.h
fconv.o: $(ARBHOME)/INCLUDE/arbdb_base.h
fconv.o: $(ARBHOME)/INCLUDE/arbdbt.h
fconv.o: $(ARBHOME)/INCLUDE/arbtools.h
fconv.o: $(ARBHOME)/INCLUDE/attributes.h
fconv.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
fconv.o: $(ARBHOME)/INCLUDE/cxxforward.h
fconv.o: $(ARBHOME)/INCLUDE/downcast.h
fconv.o: $(ARBHOME)/INCLUDE/dupstr.h
fconv.o: $(ARBHOME)/INCLUDE/gccver.h
fconv.o: $(ARBHOME)/INCLUDE/smartptr.h
fconv.o: $(ARBHOME)/INCLUDE/static_assert.h
fconv.o: $(ARBHOME)/INCLUDE/test_global.h
fconv.o: $(ARBHOME)/INCLUDE/test_unit.h

gcg.o: defs.h
gcg.o: embl.h
gcg.o: fun.h
gcg.o: genbank.h
gcg.o: global.h
gcg.o: input_format.h
gcg.o: macke.h
gcg.o: parser.h
gcg.o: prototypes.h
gcg.o: rdp_info.h
gcg.o: reader.h
gcg.o: refs.h
gcg.o: seq.h
gcg.o: $(ARBHOME)/INCLUDE/arb_assert.h
gcg.o: $(ARBHOME)/INCLUDE/arb_core.h
gcg.o: $(ARBHOME)/INCLUDE/arb_defs.h
gcg.o: $(ARBHOME)/INCLUDE/arbtools.h
gcg.o: $(ARBHOME)/INCLUDE/attributes.h
gcg.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
gcg.o: $(ARBHOME)/INCLUDE/cxxforward.h
gcg.o: $(ARBHOME)/INCLUDE/dupstr.h
gcg.o: $(ARBHOME)/INCLUDE/gccver.h
gcg.o: $(ARBHOME)/INCLUDE/smartptr.h
gcg.o: $(ARBHOME)/INCLUDE/test_global.h

genbank.o: defs.h
genbank.o: fun.h
genbank.o: genbank.h
genbank.o: global.h
genbank.o: input_format.h
genbank.o: parser.h
genbank.o: prototypes.h
genbank.o: rdp_info.h
genbank.o: reader.h
genbank.o: refs.h
genbank.o: seq.h
genbank.o: wrap.h
genbank.o: $(ARBHOME)/INCLUDE/arb_assert.h
genbank.o: $(ARBHOME)/INCLUDE/arb_core.h
genbank.o: $(ARBHOME)/INCLUDE/arb_defs.h
genbank.o: $(ARBHOME)/INCLUDE/arbtools.h
genbank.o: $(ARBHOME)/INCLUDE/attributes.h
genbank.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
genbank.o: $(ARBHOME)/INCLUDE/cxxforward.h
genbank.o: $(ARBHOME)/INCLUDE/dupstr.h
genbank.o: $(ARBHOME)/INCLUDE/gccver.h
genbank.o: $(ARBHOME)/INCLUDE/smartptr.h
genbank.o: $(ARBHOME)/INCLUDE/test_global.h

macke.o: defs.h
macke.o: fun.h
macke.o: global.h
macke.o: input_format.h
macke.o: macke.h
macke.o: parser.h
macke.o: prototypes.h
macke.o: rdp_info.h
macke.o: reader.h
macke.o: seq.h
macke.o: wrap.h
macke.o: $(ARBHOME)/INCLUDE/arb_assert.h
macke.o: $(ARBHOME)/INCLUDE/arb_core.h
macke.o: $(ARBHOME)/INCLUDE/arb_defs.h
macke.o: $(ARBHOME)/INCLUDE/arbtools.h
macke.o: $(ARBHOME)/INCLUDE/attributes.h
macke.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
macke.o: $(ARBHOME)/INCLUDE/cxxforward.h
macke.o: $(ARBHOME)/INCLUDE/dupstr.h
macke.o: $(ARBHOME)/INCLUDE/gccver.h
macke.o: $(ARBHOME)/INCLUDE/smartptr.h
macke.o: $(ARBHOME)/INCLUDE/test_global.h

main.o: defs.h
main.o: fun.h
main.o: global.h
main.o: prototypes.h
main.o: $(ARBHOME)/INCLUDE/arb_assert.h
main.o: $(ARBHOME)/INCLUDE/arb_core.h
main.o: $(ARBHOME)/INCLUDE/arb_defs.h
main.o: $(ARBHOME)/INCLUDE/arbtools.h
main.o: $(ARBHOME)/INCLUDE/attributes.h
main.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
main.o: $(ARBHOME)/INCLUDE/cxxforward.h
main.o: $(ARBHOME)/INCLUDE/dupstr.h
main.o: $(ARBHOME)/INCLUDE/gccver.h
main.o: $(ARBHOME)/INCLUDE/smartptr.h
main.o: $(ARBHOME)/INCLUDE/test_global.h
main.o: $(ARBHOME)/INCLUDE/test_unit.h

mg.o: defs.h
mg.o: fun.h
mg.o: genbank.h
mg.o: global.h
mg.o: input_format.h
mg.o: macke.h
mg.o: parser.h
mg.o: prototypes.h
mg.o: rdp_info.h
mg.o: reader.h
mg.o: refs.h
mg.o: seq.h
mg.o: $(ARBHOME)/INCLUDE/arb_assert.h
mg.o: $(ARBHOME)/INCLUDE/arb_core.h
mg.o: $(ARBHOME)/INCLUDE/arb_defs.h
mg.o: $(ARBHOME)/INCLUDE/arbtools.h
mg.o: $(ARBHOME)/INCLUDE/attributes.h
mg.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
mg.o: $(ARBHOME)/INCLUDE/cxxforward.h
mg.o: $(ARBHOME)/INCLUDE/dupstr.h
mg.o: $(ARBHOME)/INCLUDE/gccver.h
mg.o: $(ARBHOME)/INCLUDE/smartptr.h
mg.o: $(ARBHOME)/INCLUDE/test_global.h

paup.o: ali.h
paup.o: defs.h
paup.o: fun.h
paup.o: global.h
paup.o: input_format.h
paup.o: paup.h
paup.o: prototypes.h
paup.o: reader.h
paup.o: seq.h
paup.o: $(ARBHOME)/INCLUDE/arb_assert.h
paup.o: $(ARBHOME)/INCLUDE/arb_core.h
paup.o: $(ARBHOME)/INCLUDE/arb_defs.h
paup.o: $(ARBHOME)/INCLUDE/arbtools.h
paup.o: $(ARBHOME)/INCLUDE/attributes.h
paup.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
paup.o: $(ARBHOME)/INCLUDE/cxxforward.h
paup.o: $(ARBHOME)/INCLUDE/dupstr.h
paup.o: $(ARBHOME)/INCLUDE/gccver.h
paup.o: $(ARBHOME)/INCLUDE/smartptr.h
paup.o: $(ARBHOME)/INCLUDE/test_global.h

phylip.o: ali.h
phylip.o: defs.h
phylip.o: fun.h
phylip.o: global.h
phylip.o: input_format.h
phylip.o: prototypes.h
phylip.o: reader.h
phylip.o: seq.h
phylip.o: $(ARBHOME)/INCLUDE/arb_assert.h
phylip.o: $(ARBHOME)/INCLUDE/arb_core.h
phylip.o: $(ARBHOME)/INCLUDE/arb_defs.h
phylip.o: $(ARBHOME)/INCLUDE/arbtools.h
phylip.o: $(ARBHOME)/INCLUDE/attributes.h
phylip.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
phylip.o: $(ARBHOME)/INCLUDE/cxxforward.h
phylip.o: $(ARBHOME)/INCLUDE/dupstr.h
phylip.o: $(ARBHOME)/INCLUDE/gccver.h
phylip.o: $(ARBHOME)/INCLUDE/smartptr.h
phylip.o: $(ARBHOME)/INCLUDE/test_global.h

printable.o: ali.h
printable.o: defs.h
printable.o: fun.h
printable.o: global.h
printable.o: input_format.h
printable.o: prototypes.h
printable.o: reader.h
printable.o: seq.h
printable.o: $(ARBHOME)/INCLUDE/arb_assert.h
printable.o: $(ARBHOME)/INCLUDE/arb_core.h
printable.o: $(ARBHOME)/INCLUDE/arb_defs.h
printable.o: $(ARBHOME)/INCLUDE/arbtools.h
printable.o: $(ARBHOME)/INCLUDE/attributes.h
printable.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
printable.o: $(ARBHOME)/INCLUDE/cxxforward.h
printable.o: $(ARBHOME)/INCLUDE/dupstr.h
printable.o: $(ARBHOME)/INCLUDE/gccver.h
printable.o: $(ARBHOME)/INCLUDE/smartptr.h
printable.o: $(ARBHOME)/INCLUDE/test_global.h

rdp_info.o: defs.h
rdp_info.o: fun.h
rdp_info.o: global.h
rdp_info.o: input_format.h
rdp_info.o: prototypes.h
rdp_info.o: rdp_info.h
rdp_info.o: reader.h
rdp_info.o: seq.h
rdp_info.o: $(ARBHOME)/INCLUDE/arb_assert.h
rdp_info.o: $(ARBHOME)/INCLUDE/arb_core.h
rdp_info.o: $(ARBHOME)/INCLUDE/arb_defs.h
rdp_info.o: $(ARBHOME)/INCLUDE/arbtools.h
rdp_info.o: $(ARBHOME)/INCLUDE/attributes.h
rdp_info.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
rdp_info.o: $(ARBHOME)/INCLUDE/cxxforward.h
rdp_info.o: $(ARBHOME)/INCLUDE/dupstr.h
rdp_info.o: $(ARBHOME)/INCLUDE/gccver.h
rdp_info.o: $(ARBHOME)/INCLUDE/smartptr.h
rdp_info.o: $(ARBHOME)/INCLUDE/test_global.h

reader.o: defs.h
reader.o: fun.h
reader.o: global.h
reader.o: input_format.h
reader.o: prototypes.h
reader.o: reader.h
reader.o: seq.h
reader.o: $(ARBHOME)/INCLUDE/arb_assert.h
reader.o: $(ARBHOME)/INCLUDE/arb_core.h
reader.o: $(ARBHOME)/INCLUDE/arb_defs.h
reader.o: $(ARBHOME)/INCLUDE/arbtools.h
reader.o: $(ARBHOME)/INCLUDE/attributes.h
reader.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
reader.o: $(ARBHOME)/INCLUDE/cxxforward.h
reader.o: $(ARBHOME)/INCLUDE/dupstr.h
reader.o: $(ARBHOME)/INCLUDE/gccver.h
reader.o: $(ARBHOME)/INCLUDE/smartptr.h
reader.o: $(ARBHOME)/INCLUDE/test_global.h

seq.o: ali.h
seq.o: defs.h
seq.o: fun.h
seq.o: global.h
seq.o: input_format.h
seq.o: prototypes.h
seq.o: reader.h
seq.o: seq.h
seq.o: $(ARBHOME)/INCLUDE/arb_assert.h
seq.o: $(ARBHOME)/INCLUDE/arb_core.h
seq.o: $(ARBHOME)/INCLUDE/arb_defs.h
seq.o: $(ARBHOME)/INCLUDE/arbtools.h
seq.o: $(ARBHOME)/INCLUDE/attributes.h
seq.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
seq.o: $(ARBHOME)/INCLUDE/cxxforward.h
seq.o: $(ARBHOME)/INCLUDE/dupstr.h
seq.o: $(ARBHOME)/INCLUDE/gccver.h
seq.o: $(ARBHOME)/INCLUDE/smartptr.h
seq.o: $(ARBHOME)/INCLUDE/test_global.h

util.o: defs.h
util.o: fun.h
util.o: global.h
util.o: input_format.h
util.o: prototypes.h
util.o: reader.h
util.o: seq.h
util.o: $(ARBHOME)/INCLUDE/arb_assert.h
util.o: $(ARBHOME)/INCLUDE/arb_core.h
util.o: $(ARBHOME)/INCLUDE/arb_defs.h
util.o: $(ARBHOME)/INCLUDE/arbtools.h
util.o: $(ARBHOME)/INCLUDE/attributes.h
util.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
util.o: $(ARBHOME)/INCLUDE/cxxforward.h
util.o: $(ARBHOME)/INCLUDE/dupstr.h
util.o: $(ARBHOME)/INCLUDE/gccver.h
util.o: $(ARBHOME)/INCLUDE/smartptr.h
util.o: $(ARBHOME)/INCLUDE/test_global.h

wrap.o: defs.h
wrap.o: fun.h
wrap.o: global.h
wrap.o: input_format.h
wrap.o: prototypes.h
wrap.o: reader.h
wrap.o: seq.h
wrap.o: wrap.h
wrap.o: $(ARBHOME)/INCLUDE/arb_assert.h
wrap.o: $(ARBHOME)/INCLUDE/arb_core.h
wrap.o: $(ARBHOME)/INCLUDE/arb_defs.h
wrap.o: $(ARBHOME)/INCLUDE/arbtools.h
wrap.o: $(ARBHOME)/INCLUDE/attributes.h
wrap.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
wrap.o: $(ARBHOME)/INCLUDE/cxxforward.h
wrap.o: $(ARBHOME)/INCLUDE/dupstr.h
wrap.o: $(ARBHOME)/INCLUDE/gccver.h
wrap.o: $(ARBHOME)/INCLUDE/smartptr.h
wrap.o: $(ARBHOME)/INCLUDE/test_global.h

=== EISPACK/Makefile ===
# for variables passed from parent makefile see ../SOURCE_TOOLS/parent_make.txt

.SUFFIXES: .o .cxx .depend


CPP_OBJECTS =  eispack.o d_sign.o

$(MAIN): $(CPP_OBJECTS)
	$(LINK_STATIC_LIB) $(MAIN) $(CPP_OBJECTS)

clean:
	rm -f $(CPP_OBJECTS) *.a

.cxx.o:
	$(A_CXX) $(cflags) $(cxxflags) -c $< $(CXX_INCLUDES) $(POST_COMPILE)

DEPENDS = $(CPP_OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

d_sign.o: f2c.h

eispack.o: f2c.h

=== GDE/Makefile ===

ARCHS_COMMON_DEPENDS = \
	CLUSTAL/CLUSTAL.dummy  \
	SUPPORT/SUPPORT.dummy \
	AxML/AxML.dummy \

ARCHS_COMMON_NO_DEPENDS = \
	PHYML20130708/PHYML20130708.dummy \

# --------------------------------------------------------------------------------
# If a package is available as debian package it should go here
# 
# Note: I'm not sure whether this is a good idea. Due to limited manpower it often takes
# longer until ARB works with newer (incompatible) versions of these tools. --ralf

ARCHS_NON_DEBIAN_DEPENDS = \
	CLUSTALW/CLUSTALW.dummy  \
	FASTDNAML/FASTDNAML.dummy \
	MrBAYES/MrBAYES.dummy \
	PHYLIP/PHYLIP.dummy \
	PHYML/PHYML.dummy \
	RAxML/RAxML.dummy \
	TREEPUZZLE/TREEPUZZLE.dummy \

ARCHS_NON_DEBIAN_NO_DEPENDS = \
	FASTTREE/FASTTREE.dummy \
	MAFFT/MAFFT.dummy \
	MUSCLE/MUSCLE.dummy \
	PROBCONS/PROBCONS.dummy \

# --------------------------------------------------------------------------------

ifeq ($(DEBIAN),1)
ARCHS_DEPENDS    = $(ARCHS_COMMON_DEPENDS)
ARCHS_NO_DEPENDS = $(ARCHS_COMMON_NO_DEPENDS)
else
ARCHS_DEPENDS    = $(ARCHS_COMMON_DEPENDS)    $(ARCHS_NON_DEBIAN_DEPENDS)
ARCHS_NO_DEPENDS = $(ARCHS_COMMON_NO_DEPENDS) $(ARCHS_NON_DEBIAN_NO_DEPENDS)
endif

ARCHS=$(ARCHS_DEPENDS) $(ARCHS_NO_DEPENDS)

# --------------------------------------------------------------------------------
# modify cflags for submakefiles 

RAISE_WARNINGS=0# no warnings in this subtree
UNIT_TESTS=0# no tests in this subtree

sub_cflags:=$(cflags)

ifeq ('$(RAISE_WARNINGS)','0')
sub_cflags:=$(subst -W -Wall,-w,$(sub_cflags))
endif
ifeq ('$(UNIT_TESTS)','0')
sub_cflags:=$(subst -DUNIT_TESTS,,$(sub_cflags))
endif

# note the above does not affect all subdirs. see also manual changes to:
# - MrBAYES/mrbayes_3.2.1/Makefile
# - PROBCONS/probcons/Makefile
# - FASTTREE/Makefile

# --------------------------------------------------------------------------------

$(MAIN):
ifeq ('$(RAISE_WARNINGS)','0')
	@echo ----------------- non-ARB code: warnings disabled
endif
	$(MAKE) $(ARCHS)
ifeq ('$(RAISE_WARNINGS)','0')
	@echo ----------------- warnings enabled again
endif

depends: $(ARCHS_DEPENDS:.dummy=.depend)

clean: $(ARCHS:.dummy=.clean)

%.depend:
	@cp -p $(@D)/Makefile $(@D)/Makefile.old # save old Makefile
	@$(MAKE) -C $(@D) -r depends
	@grep "^# DO NOT DELETE" $(@D)/Makefile >/dev/null || \
		(echo "$(@D)/Makefile:666: Error: No dependencies in $(@D)/Makefile"; false) # check whether sub Makefile has dependencies
	@$(ARBHOME)/SOURCE_TOOLS/fix_depends.pl "(from GDE)" < $(@D)/Makefile > $(@D)/Makefile.2
	@mv $(@D)/Makefile.old $(@D)/Makefile # restore old Makefile
	@$(ARBHOME)/SOURCE_TOOLS/mv_if_diff $(@D)/Makefile.2 $(@D)/Makefile # update Makefile if changed

%.dummy:
	+@( \
	(( \
	    echo "$(SEP) Make $(@D)"; \
	    $(MAKE) -C $(@D) -r \
		"ARB  = yes" \
		"MAIN = $(@F:.dummy=.a)" \
		"cflags = $(sub_cflags) -DIN_ARB_$(@D:/=)" && \
	    echo "$(SEP) Make $(@D) [done]"; \
	) >$(@D).$$ID.log 2>&1 && (cat $(@D).$$ID.log;rm $(@D).$$ID.log)) || (cat $(@D).$$ID.log;rm $(@D).$$ID.log;false))

%.clean:
	+@$(MAKE) -C $(@D) \
		"ARB  = yes" \
		clean

%.proto:
	@$(MAKE) -C $(@D) \
		proto

# the end of the above command avoids that the output of parallel make calls gets mixed up 

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

=== GDEHELP/Makefile ===

MENUS_TGT = $(ARBHOME)/lib/gde/arb.menu
MENUS_SRC = ARB_GDEmenus.source

SED:=$(ARBHOME)/SH/arb_sed

HELPFILELIST=helpfiles.lst
GENHELPDEST=./HELP_GEN
GENDOCDEST=./HELP_DOC_GEN

SUBMENUS=$(wildcard MENUS/*.menu)
GENMENUS=$(SUBMENUS:.menu=.genmenu)

PPP:=./pp.pl
CLEAN:=./cleanmenu.pl

# ---------------------------------------- help for refactoring
MENUS_EXPECTED = ARB_GDEmenus.expected

# check expected result (to avoid unwanted changes)
# call 'make update_expected' to expect the current result

#CHECK_AS_EXPECTED = check_as_expected
CHECK_AS_EXPECTED = 

# ----------------------------------------

all: $(MENUS_TGT) help $(CHECK_AS_EXPECTED) rm_obsolete

MENUS/%.genmenu : genmenu.header

MENUS/%.genmenu : MENUS/%.menu
		( cat genmenu.header; $(SED) -e "s/^[ ]*//" ) < $< > $@

MENUS_DIRTY=ARB_GDEmenus.dirty

$(MENUS_DIRTY) : $(MENUS_SRC) $(GENMENUS) Makefile $(PPP)
	$(PPP) -IMENUS $(MENUS_SRC) >$@

$(MENUS_TGT) : $(MENUS_DIRTY) $(CLEAN)
	-chmod a+w $@
	$(CLEAN) <$(MENUS_DIRTY) >$@
	rm $(MENUS_DIRTY)
	chmod a-w $@

# ------------------------------------------------------------

update_expected: $(MENUS_TGT)
	cp $(MENUS_TGT) $(MENUS_EXPECTED)

check_as_expected: $(MENUS_TGT) $(MENUS_EXPECTED)
	diff --unified --ignore-space-change --ignore-blank-lines  $(MENUS_EXPECTED) $(MENUS_TGT) 

# ------------------------------------------------------------

help: $(HELPFILELIST)
	@test -d $(GENHELPDEST) || mkdir $(GENHELPDEST)
	@test -d $(GENDOCDEST) || mkdir $(GENDOCDEST)
	@$(MAKE) -f Makefile.helpfiles "GENHELPDEST=$(GENHELPDEST)" "GENDOCDEST=$(GENDOCDEST)" "HELPFILELIST=$(HELPFILELIST)"

$(HELPFILELIST): $(SUBMENUS) Makefile
	grep -ih '^itemhelp:' $(SUBMENUS) | $(SED) -e 's/^itemhelp://' | sort | uniq > $@

# ------------------------------------------------------------

rm_obsolete:
	@(test -f ARB_GDEmenus && rm -f ARB_GDEmenus) || true

clean: $(HELPFILELIST)
	@$(MAKE) -f Makefile.helpfiles \
		"GENHELPDEST=$(GENHELPDEST)" \
		"GENDOCDEST=$(GENDOCDEST)" \
		"HELPFILELIST=$(HELPFILELIST)" \
		clean
	rm -f $(GENMENUS) $(MENUS_TGT) $(HELPFILELIST)

=== GL/Makefile ===

ARCHS_ALL = \
	glpng/libglpng_arb.dummy  \
	glAW/libglAW.dummy  \

# --------------------------------------------------------------------------------
# If a package is available as debian package it should go here

ARCHS_NON_DEBIAN = \

# --------------------------------------------------------------------------------

ifeq ($(DEBIAN),1)
ARCHS = $(ARCHS_ALL) 
else
ARCHS = $(ARCHS_ALL) $(ARCHS_NON_DEBIAN)
endif

# --------------------------------------------------------------------------------
# warnings in this subtree?

RAISE_WARNINGS=1

ifeq ($(RAISE_WARNINGS),0)
cflags:=$(cflags:-W -Wall=-w)
endif

include $(ARBHOME)/SOURCE_TOOLS/export2sub

# --------------------------------------------------------------------------------

$(MAIN): $(ARCHS)

depends: $(ARCHS:.dummy=.depend)

clean: $(ARCHS:.dummy=.clean)

%.depend:
	@cp -p $(@D)/Makefile $(@D)/Makefile.old # save old Makefile
	@$(MAKE) -C $(@D) -r depends
	@grep "^# DO NOT DELETE" $(@D)/Makefile >/dev/null # check whether sub Makefile has dependencies
	@cat $(@D)/Makefile \
		| ../SOURCE_TOOLS/fix_depends.pl "(from GL)" \
		>$(@D)/Makefile.2
	@mv $(@D)/Makefile.old $(@D)/Makefile # restore old Makefile
	@$(ARBHOME)/SOURCE_TOOLS/mv_if_diff $(@D)/Makefile.2 $(@D)/Makefile # update Makefile if changed

%.dummy:
	@$(MAKE) -C $(@D) -r \
		"ARB  = yes" \
		"MAIN = $(@F:.dummy=.a)" \
		"cflags = $(cflags) -DIN_ARB_$(@D:/=)" \

%.clean:
	@$(MAKE) -C $(@D) \
		clean

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

=== HEADERLIBS/Makefile ===

all: eigen

clean:
	rm -rf eigen/

eigen: eigen.tgz
	tar -zxvf $<
	touch eigen/

=== NALIGNER/Makefile ===
# for variables passed from parent makefile see ../SOURCE_TOOLS/parent_make.txt

.SUFFIXES: .o .c .cxx .depend

CPP_OBJECTS = \
	ali_aligner.o \
	ali_arbdb.o \
	ali_global.o \
	ali_main.o \
	ali_pathmap.o \
	ali_prealigner.o \
	ali_profile.o \
	ali_pt.o \
	ali_sequence.o \
	ali_solution.o \

$(MAIN): $(CPP_OBJECTS)
	$(LINK_STATIC_LIB) $(MAIN) $(CPP_OBJECTS)

.cxx.o:
	$(A_CXX) $(cflags) $(cxxflags) -c -o $@ $< $(CXX_INCLUDES) $(POST_COMPILE)

clean:
	rm -f $(CPP_OBJECTS) *.a

DEPENDS = $(CPP_OBJECTS:.o=.depend)
depends: $(DEPENDS)
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE THIS LINE -- make depend depends on it.

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

ali_aligner.o: ali_aligner.hxx
ali_aligner.o: ali_arbdb.hxx
ali_aligner.o: ali_misc.hxx
ali_aligner.o: ali_other_stuff.hxx
ali_aligner.o: ali_pathmap.hxx
ali_aligner.o: ali_profile.hxx
ali_aligner.o: ali_pt.hxx
ali_aligner.o: ali_sequence.hxx
ali_aligner.o: ali_solution.hxx
ali_aligner.o: ali_tarray.hxx
ali_aligner.o: ali_tlist.hxx
ali_aligner.o: ali_tstack.hxx
ali_aligner.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_aligner.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_aligner.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_aligner.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_aligner.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_aligner.o: $(ARBHOME)/INCLUDE/attributes.h
ali_aligner.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_aligner.o: $(ARBHOME)/INCLUDE/client.h
ali_aligner.o: $(ARBHOME)/INCLUDE/client_types.h
ali_aligner.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_aligner.o: $(ARBHOME)/INCLUDE/downcast.h
ali_aligner.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_aligner.o: $(ARBHOME)/INCLUDE/gccver.h
ali_aligner.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_aligner.o: $(ARBHOME)/INCLUDE/server.h
ali_aligner.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_aligner.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_aligner.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_aligner.o: $(ARBHOME)/INCLUDE/test_global.h

ali_arbdb.o: ali_arbdb.hxx
ali_arbdb.o: ali_misc.hxx
ali_arbdb.o: ali_other_stuff.hxx
ali_arbdb.o: ali_sequence.hxx
ali_arbdb.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/attributes.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/downcast.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/gccver.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/server.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_arbdb.o: $(ARBHOME)/INCLUDE/test_global.h

ali_global.o: ali_arbdb.hxx
ali_global.o: ali_global.hxx
ali_global.o: ali_misc.hxx
ali_global.o: ali_other_stuff.hxx
ali_global.o: ali_pathmap.hxx
ali_global.o: ali_prealigner.hxx
ali_global.o: ali_profile.hxx
ali_global.o: ali_pt.hxx
ali_global.o: ali_sequence.hxx
ali_global.o: ali_solution.hxx
ali_global.o: ali_tarray.hxx
ali_global.o: ali_tlist.hxx
ali_global.o: ali_tstack.hxx
ali_global.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_global.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_global.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_global.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_global.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_global.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_global.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_global.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_global.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_global.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_global.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_global.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_global.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_global.o: $(ARBHOME)/INCLUDE/attributes.h
ali_global.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_global.o: $(ARBHOME)/INCLUDE/client.h
ali_global.o: $(ARBHOME)/INCLUDE/client_types.h
ali_global.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_global.o: $(ARBHOME)/INCLUDE/downcast.h
ali_global.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_global.o: $(ARBHOME)/INCLUDE/gccver.h
ali_global.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_global.o: $(ARBHOME)/INCLUDE/server.h
ali_global.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_global.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_global.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_global.o: $(ARBHOME)/INCLUDE/test_global.h

ali_main.o: ali_arbdb.hxx
ali_main.o: ali_global.hxx
ali_main.o: ali_misc.hxx
ali_main.o: ali_other_stuff.hxx
ali_main.o: ali_pathmap.hxx
ali_main.o: ali_prealigner.hxx
ali_main.o: ali_profile.hxx
ali_main.o: ali_pt.hxx
ali_main.o: ali_sequence.hxx
ali_main.o: ali_solution.hxx
ali_main.o: ali_tarray.hxx
ali_main.o: ali_tlist.hxx
ali_main.o: ali_tstack.hxx
ali_main.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_main.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_main.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_main.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_main.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_main.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_main.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_main.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_main.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_main.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_main.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_main.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_main.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_main.o: $(ARBHOME)/INCLUDE/attributes.h
ali_main.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_main.o: $(ARBHOME)/INCLUDE/client.h
ali_main.o: $(ARBHOME)/INCLUDE/client_types.h
ali_main.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_main.o: $(ARBHOME)/INCLUDE/downcast.h
ali_main.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_main.o: $(ARBHOME)/INCLUDE/gccver.h
ali_main.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_main.o: $(ARBHOME)/INCLUDE/server.h
ali_main.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_main.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_main.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_main.o: $(ARBHOME)/INCLUDE/test_global.h

ali_pathmap.o: ali_misc.hxx
ali_pathmap.o: ali_pathmap.hxx
ali_pathmap.o: ali_tarray.hxx
ali_pathmap.o: ali_tlist.hxx
ali_pathmap.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_pathmap.o: $(ARBHOME)/INCLUDE/attributes.h
ali_pathmap.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_pathmap.o: $(ARBHOME)/INCLUDE/gccver.h

ali_prealigner.o: ali_aligner.hxx
ali_prealigner.o: ali_arbdb.hxx
ali_prealigner.o: ali_misc.hxx
ali_prealigner.o: ali_other_stuff.hxx
ali_prealigner.o: ali_pathmap.hxx
ali_prealigner.o: ali_prealigner.hxx
ali_prealigner.o: ali_profile.hxx
ali_prealigner.o: ali_pt.hxx
ali_prealigner.o: ali_sequence.hxx
ali_prealigner.o: ali_solution.hxx
ali_prealigner.o: ali_tarray.hxx
ali_prealigner.o: ali_tlist.hxx
ali_prealigner.o: ali_tstack.hxx
ali_prealigner.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/attributes.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/client.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/client_types.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/downcast.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/gccver.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/server.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_prealigner.o: $(ARBHOME)/INCLUDE/test_global.h

ali_profile.o: ali_arbdb.hxx
ali_profile.o: ali_misc.hxx
ali_profile.o: ali_other_stuff.hxx
ali_profile.o: ali_profile.hxx
ali_profile.o: ali_pt.hxx
ali_profile.o: ali_sequence.hxx
ali_profile.o: ali_tlist.hxx
ali_profile.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_profile.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_profile.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_profile.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_profile.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_profile.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_profile.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_profile.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_profile.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_profile.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_profile.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_profile.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_profile.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_profile.o: $(ARBHOME)/INCLUDE/attributes.h
ali_profile.o: $(ARBHOME)/INCLUDE/BI_helix.hxx
ali_profile.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_profile.o: $(ARBHOME)/INCLUDE/client.h
ali_profile.o: $(ARBHOME)/INCLUDE/client_types.h
ali_profile.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_profile.o: $(ARBHOME)/INCLUDE/downcast.h
ali_profile.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_profile.o: $(ARBHOME)/INCLUDE/gccver.h
ali_profile.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_profile.o: $(ARBHOME)/INCLUDE/server.h
ali_profile.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_profile.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_profile.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_profile.o: $(ARBHOME)/INCLUDE/test_global.h

ali_pt.o: ali_misc.hxx
ali_pt.o: ali_other_stuff.hxx
ali_pt.o: ali_pt.hxx
ali_pt.o: ali_sequence.hxx
ali_pt.o: ali_tlist.hxx
ali_pt.o: $(ARBHOME)/INCLUDE/ad_prot.h
ali_pt.o: $(ARBHOME)/INCLUDE/ad_t_prot.h
ali_pt.o: $(ARBHOME)/INCLUDE/aisc_func_types.h
ali_pt.o: $(ARBHOME)/INCLUDE/aisc_global.h
ali_pt.o: $(ARBHOME)/INCLUDE/arb_assert.h
ali_pt.o: $(ARBHOME)/INCLUDE/arb_core.h
ali_pt.o: $(ARBHOME)/INCLUDE/arb_error.h
ali_pt.o: $(ARBHOME)/INCLUDE/arb_msg.h
ali_pt.o: $(ARBHOME)/INCLUDE/arb_string.h
ali_pt.o: $(ARBHOME)/INCLUDE/arbdb.h
ali_pt.o: $(ARBHOME)/INCLUDE/arbdb_base.h
ali_pt.o: $(ARBHOME)/INCLUDE/arbdbt.h
ali_pt.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_pt.o: $(ARBHOME)/INCLUDE/attributes.h
ali_pt.o: $(ARBHOME)/INCLUDE/bytestring.h
ali_pt.o: $(ARBHOME)/INCLUDE/client.h
ali_pt.o: $(ARBHOME)/INCLUDE/client_types.h
ali_pt.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_pt.o: $(ARBHOME)/INCLUDE/downcast.h
ali_pt.o: $(ARBHOME)/INCLUDE/dupstr.h
ali_pt.o: $(ARBHOME)/INCLUDE/gccver.h
ali_pt.o: $(ARBHOME)/INCLUDE/PT_com.h
ali_pt.o: $(ARBHOME)/INCLUDE/server.h
ali_pt.o: $(ARBHOME)/INCLUDE/servercntrl.h
ali_pt.o: $(ARBHOME)/INCLUDE/smartptr.h
ali_pt.o: $(ARBHOME)/INCLUDE/static_assert.h
ali_pt.o: $(ARBHOME)/INCLUDE/test_global.h

ali_sequence.o: ali_misc.hxx
ali_sequence.o: ali_sequence.hxx
ali_sequence.o: $(ARBHOME)/INCLUDE/arbtools.h
ali_sequence.o: $(ARBHOME)/INCLUDE/attributes.h
ali_sequence.o: $(ARBHOME)/INCLUDE/cxxforward.h
ali_sequence.o: $(ARBHOME)/INCLUDE/gccver.h

=== PERLTOOLS/Makefile ===
.SUFFIXES: .c .cxx .depend .o

TOOLS := \
	arb_proto_2_xsub \

LIB_ARBDB            := $(LIBPATH) $(ARBDB_LIB) $(ARB_GLIB_LIBS)
LIBS_ARB_PROBE       := ../SERVERCNTRL/SERVERCNTRL.a ../PROBE_COM/client.a
LIBS_ARB_READ_TREE   := ../SL/TREE_READ/TREE_READ.a
LIBS_ARB_EXPORT_TREE := ../SL/TREE_WRITE/TREE_WRITE.a ../XML/XML.a $(LIBS_ARB_READ_TREE)

OBJECTS:=$(addsuffix .o,$(TOOLS))
BINARIES:=$(addprefix $(ARBHOME)/bin/,$(TOOLS))

all: $(BINARIES)

%.o: %.cxx 
	$(A_CXX) $(cflags) $(cxxflags) -c $< $(CXX_INCLUDES) $(POST_COMPILE)

%.o: %.c
	$(A_CC) $(cflags) -c $< $(CC_INCLUDES) $(POST_COMPILE)

$(ARBHOME)/bin/%: %.o $(use_ARB_main)
	$(LINK_EXECUTABLE) $@ $(use_ARB_main) $< $(LIB_ARBDB) $(EXECLIBS)

clean:
	rm -f $(BINARIES)
	rm -f $(OBJECTS)

proto:
	@echo "Nothing todo for proto in PERLTOOLS"

depends:
	$(MAKE) "DEBUG=1" depends_debug

DEPENDS = $(OBJECTS:.o=.depend)
depends_debug: $(DEPENDS) 
	@cat $(DEPENDS) | grep -v '^#' >>Makefile
	@rm $(DEPENDS)
$(DEPENDS): depend.init
depend.init:
	$(MAKEDEPEND) $(MAKEDEPENDFLAGS) 2>/dev/null # remove dependencies
.cxx.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@
.c.depend:
	$(MAKEDEPEND) -f- $(MAKEDEPENDFLAGS) $< 2>/dev/null >$@

# DO NOT DELETE

# Do not add dependencies manually - use 'make depend' in $ARBHOME
# For formatting issues see SOURCE_TOOLS/fix_depends.pl (from main)

arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/ad_prot.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_assert.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_core.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_diff.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_error.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_msg.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_str.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_strbuf.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arb_string.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arbdb.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arbdb_base.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/arbtools.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/attributes.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/BufferedFileReader.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/cxxforward.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/dupstr.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/gccver.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/smartptr.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/test_global.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/test_unit.h
arb_proto_2_xsub.o: $(ARBHOME)/INCLUDE/ut_valgrinded.h

=== debian/changelog ===
arb (6.0.3-1) unstable; urgency=medium

  * New upstream version
  * Applied all l10n patches - thanks a lot for the great l10n team
    for pushing this
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #761942
  * [Debconf translation updates]
  * Danish (Joe Hansen).  Closes: #764869
  * Dutch; (Frans Spiesschaert).  Closes: #765088
  * Russian (Yuri Kozlov).  Closes: #765096
  * Portuguese (Américo Monteiro).  Closes: #761503
  * Danish (Joe Hansen).  Closes: #765865
  * Czech (Michal Simunek).  Closes: #766600
  * Italian (Daniele Forsi).  Closes: #766684
  * German (Chris Leick).  Closes: #766689
  * French (Steve Petruzzello).  Closes: #766728
  * Catalan; (Innocent De Marchi).  Closes: #766855
  * Japanese (Hideki Yamane (Debian-JP)).  Closes: #767247
  * extra linker flag proposed by Tim Booth
  * Lintian override to avoid false positives
  * cme fix dpkg-control
  * spelling+lintian fixes in d/copyright

 -- Andreas Tille <tille@debian.org>  Thu, 10 Dec 2015 12:26:14 +0100

arb (6.0.2-2) unstable; urgency=medium

  [ Elmar Pruesse ]
   * Add Portugese debconf translation (thanks to Américo Monteiro 
     <a_monteiro@gmx.com> for the patch)
     Closes: #761503
   * Add Russian debconf translation (thanks to Yuri Kozlov 
     <yuray@komyakino.ru> for the patch)
     Closes: #761616
   * debian/arb_CHANGELOG.txt -> debian/changelog (fix lintian complaint)

  [ Andreas Tille ]
  * Skip compiler version check at all
    Closes: #793187

 -- Andreas Tille <tille@debian.org>  Wed, 22 Jul 2015 22:49:16 +0200

=== debian/control ===
Source: arb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Elmar Pruesse <elmar@pruesse.net>
Section: non-free/science
XS-Autobuild: yes
Priority: optional
Build-Depends: chrpath,
               debhelper (>= 9),
               freeglut3-dev | libglu-dev,
               libbio-perl-perl,
               libglew-dev,
               libglib2.0-dev,
               libglw1-mesa-dev,
               libglu1-mesa-dev,
               libmotif-dev,
               libpng-dev,
               libtiff-dev,
               libxaw7-dev,
               libxml2-utils,
               libxpm-dev,
               lynx,
               time,
               perl-doc,
               xsltproc,
               xutils-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/arb/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/arb/trunk/
Homepage: http://www.arb-home.de/

Package: arb
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Depends: arb-common (= ${source:Version}),
         fastdnaml,
         libarb (= ${binary:Version}),
         openssh-client,
         mafft,
         mrbayes,
         phylip,
         phyml,
         raxml,
         readseq,
         transfig,
         tree-puzzle,
         xdg-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: bioperl,
            xfig
Suggests: arb-database,
          gnuplot,
          gv
Description: phylogenetic sequence analysis suite - main program
 ARB is a graphical suite of tools for sequence database handling and data
 analysis. A central database of processed (aligned) sequences and any
 type of additional data linked to the sequence entries is structured
 according to phylogeny or other user-defined criteria.
 .
 The ARB project (from the Latin "arbor", a tree) is a joint initiative of
 the Lehrstuhl fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/
 and the Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.

Package: libarb
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: arb
Description: phylogenetic sequence analysis suite - libraries
 ARB is a graphical suite of tools for sequence database handling and data
 analysis. A central database of processed (aligned) sequences and any
 type of additional data linked to the sequence entries is structured
 according to phylogeny or other user-defined criteria.
 .
 The ARB project (from the Latin "arbor", a tree) is a joint initiative of
 the Lehrstuhl fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/
 and the Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package provides the dynamic libraries which are used by ARB.

Package: libarb-dev
Architecture: amd64 i386 kfreebsd-i386 kfreebsd-amd64
Section: non-free/libdevel
Depends: libarb (= ${binary:Version}),
         ${misc:Depends}
Description: phylogenetic sequence analysis suite - development files
 ARB is a graphical suite of tools for sequence database handling and data
 analysis. A central database of processed (aligned) sequences and any
 type of additional data linked to the sequence entries is structured
 according to phylogeny or other user-defined criteria.
 .
 The ARB project (from the Latin "arbor", a tree) is a joint initiative of
 the Lehrstuhl fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/
 and the Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package provides headers and static libs needed to link against
 libARBDB.

Package: arb-common
Architecture: all
Depends: adduser,
         arb-doc (= ${source:Version}),
         ghostscript | postscript-preview,
         gv | postscript-viewer,
         perl-modules,
         ${misc:Depends},
         ${perl:Depends}
Recommends: arb
Description: phylogenetic sequence analysis suite - common files
 ARB is a graphical suite of tools for sequence database handling and data
 analysis. A central database of processed (aligned) sequences and any
 type of additional data linked to the sequence entries is structured
 according to phylogeny or other user-defined criteria.
 .
 The ARB project (from the Latin "arbor", a tree) is a joint initiative of
 the Lehrstuhl fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/
 and the Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package provides the architecture independent scripts of ARB.

Package: arb-doc
Architecture: all
Section: non-free/doc
Depends: ghostscript | postscript-preview,
         gv | postscript-viewer,
         ${misc:Depends}
Suggests: arb
Description: phylogenetic sequence analysis suite - documentation
 ARB is a graphical suite of tools for sequence database handling and data
 analysis. A central database of processed (aligned) sequences and any
 type of additional data linked to the sequence entries is structured
 according to phylogeny or other user-defined criteria.
 .
 The ARB project (from the Latin "arbor", a tree) is a joint initiative of
 the Lehrstuhl fuer Mikrobiologie http://www.mikro.biologie.tu-muenchen.de/
 and the Lehrstuhl fuer Rechnertechnik und Rechnerorganisation
 http://wwwbode.informatik.tu-muenchen.de/ of the Technical University
 of Munich.
 .
 This package provides the documentation for ARB.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for arb using quilt

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
pkgcom=$(pkg)-common
pkgdoc=$(pkg)-doc
common=debian/$(pkgcom)

ARBHOME=$(CURDIR)

BITARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
ifeq ($(BITARCH),64)
    ARB_64:=1
else
    ARB_64:=0
endif

LD_LIBRARY_PATH := $(ARBHOME)/lib:$(LD_LIBRARY_PATH)
PATH := $(ARBHOME)/bin:$(PATH)
LC_ALL := C

export ARBHOME LD_LIBRARY_PATH PATH LC_ALL

%:
	dh $@ --parallel

config.makefile: config.makefile.template
	# ARB's build system is configured with config.makefile. This file is
	# created on the first run of make from config.makefile.template. We
	# just use sed here to set the desired parameters:
	sed -e 's/DEVELOPER := ANY/DEVELOPER := RELEASE/;'\
            -e 's/ARB_64 := 1/ARB_64 := $(ARB_64)/;'\
            -e 's/# DEBIAN := 1/DEBIAN := 1/;' \
             config.makefile.template > config.makefile

override_dh_auto_build:
	$(MAKE) all

override_dh_auto_configure: config.makefile

override_dh_auto_clean: config.makefile
	# config.makefile is required to run make clean, hence the dependency
	# on ..._auto_configure.
	$(MAKE) clean
	rm config.makefile
	# ARB does not have "distclean" or "realclean". Remove some leftovers:
	rm -f UNIT_TESTER/Makefile.setup.local
	find -name \*.log -a ! -name phyml-manual.log -print0 | xargs -0 rm -f
	rm -f TEMPLATES/arb_build.h

override_dh_install:
	# ARB has no "install" target. It has "tarfile_quick", though, which
	# creates a tarball for distribution. We build this and unpack it
	# into debian/tmp so that dh_install can pick up the files.
	make tarfile_quick
	rm -rf debian/tmp
	mkdir debian/tmp
	tar -C debian/tmp -xzf arb.tgz
	rm -rf debian/tmp-dev
	mkdir debian/tmp-dev
	tar -C debian/tmp-dev -xzf arb-dev.tgz
	rm arb.tgz arb-dev.tgz

	# remove some files we don't need in the package:
	rm -rf debian/tmp/lib/addlibs # external libs are packages
	rm  -f debian/tmp/lib/arb_tcp_org.dat # managed in etc
	rm  -f debian/tmp/lib/GPL.txt # included in copyright
	rm  -f debian/tmp/lib/Makefile # spurious in upstream
	rm  -f debian/tmp/arb_install.sh # no installer needed
	rm  -f debian/tmp/arb_INSTALL.txt
	rm  -f debian/tmp/arb_OS_X_MacPorts.txt
	rm  -f debian/tmp/arb_OS_X.txt
	rm  -f debian/tmp/arb_UBUNTU.txt

	dh_install --list-missing

	# the check is needed to make sure it will not fail when doing binary-arch only builds
	if [ -e debian/$(pkgcom)/usr/lib/arb/SH/arb_create_debian_conffile ] ; then \
	    # Move SH/README :to docs \
	    cp -a SH/README debian/$(pkgcom)/usr/share/doc/arb/README_SH ; \
	    # Fix permission of scripts \
	    chmod a+x debian/$(pkgcom)/usr/lib/arb/SH/arb_create_debian_conffile ; \
	    chmod a+x debian/$(pkgcom)/usr/lib/arb/lib/macro.head ; \
	fi

override_dh_strip:
	# Fix rpath issue (once libarb is installed)
	if [ -e debian/libarb/usr/lib/arb/lib/ARB.so ] ; then \
	    chrpath --delete debian/libarb/usr/lib/arb/lib/ARB.so ; \
	fi
	dh_strip 
	find debian/libarb-dev -name \*.a -print0 | xargs -0 -n 1 strip --remove-section=.comment

override_dh_shlibdeps:
	dh_shlibdeps -a -l debian/libarb/usr/lib

override_dh_builddeb:
	dh_builddeb -- -Z xz

override_dh_fixperms:
	dh_fixperms
	-chmod 0644 debian/arb-common/etc/arb/submit/*
	-chmod 0644 debian/libarb-dev/usr/include/arb/xml.hxx
	-chmod 0755 debian/arb-common/usr/lib/arb/lib/macro.head

# To update po files as recommended in po-debconf(7) 
debian/po/templates.pot: debian/arb-common.templates
	@debconf-updatepo

=== debian/watch ===
version=3
#opts="downloadurlmangle=s/$/arbsrc.tgz/,filenamemangle=s/\/$/.tgz/" \
#   http://download.arb-home.de/release/ arb_(\d+.*)/

opts="downloadurlmangle=s{([\d.]+)/$}{$1/arb-$1-source.tgz},filenamemangle=s/\/$/.tgz/" \
   http://download.arb-home.de/release/ arb-(\d+.*)/
